<?php session_start(); ?>
<!DOCTYPE HTML>
<html>
<head>
  <meta charset="utf-8">
  <title>Administrator Panel</title>
  <link rel="stylesheet" type="text/css" href="css/styles.css"/>
  <link href="inc/pagination/css/pagination.css" rel="stylesheet" type="text/css"/>
  <link href="inc/pagination/css/red.css" rel="stylesheet" type="text/css"/>
  <link href="inc/pagination/css/page.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<?php
include_once('inc/core.php');
include_once('inc/pagination/function.php');

if (loggedin() == false) {
  echo '<meta http-equiv="refresh" content="0; URL=login.php">';
  die;
}

$page = (int) (!isset($_GET["page"]) ? 1 : $_GET["page"]);
$limit = 10;
$startpoint = ($page * $limit) - $limit;

//search criterias
@$name = $_GET['name'];
@$email = $_GET['email'];
@$tnx_id = $_GET['tnx_id'];
@$amount = $_GET['amount'];
@$term = $_GET['term'];
@$search = $_GET['search'];

if (isset($_GET['search']) == true && !empty($_GET['search'])) {
  if ($search == 'name') {
    $statement = "transactions WHERE name LIKE '%" . sanitize($term) . "%' ";
  }
  if ($search == 'email') {
    $statement = "transactions WHERE email= '" . sanitize($term) . "' OR  email LIKE '%" . sanitize($term) . "%@%'";
  }
  if ($search == 'tnx_id') {
    $statement = "transactions WHERE transaction_id= '" . sanitize($term) . "' ";
  }
  if ($search == 'amount') {
    $statement = "transactions WHERE paid_amount= '" . sanitize($term) . "' ";
  }

}
else {
  $statement = "`transactions`";
}
$order = 'payment_date DESC';

if (isset($_GET['order'])) {

  if ($_GET['order'] == 'date' && $_GET['accending'] == 'true') {
    $order = 'payment_date ASC';
  }
  else {
    $order = 'payment_date DESC';
  }

  if ($_GET['order'] == 'name') {
    $order = 'name ';
  }

  if ($_GET['order'] == 'email') {
    $order = 'email';
  }


}

$statement .= "  ORDER BY  {$order}";

?>
<div id="header">
  <div class="home_btn"><a href="index.php"><img border="0" src="img/home.png"/></a></div>
  <div class="welcome_msg">Welcome <strong>Administrator</strong> | <a href="services.php">Services</a> |
    <a href="settings.php">Settings</a> | <a href="logout.php">Log Out</a></div>
</div>
<div id="wrapper">
  <div class="innerhead">
    <?php
    if (isset($_GET['search']) == true) {
      ?>
      <div class="title">Search Results</div>
      <div class="desc">
        <div style="height: 35px; float: left; margin-right: 10px; margin-top: -5px;">
          <a href="index.php"><img border="0" title="Return Home" src="img/return_home.png"/></a>
        </div>
        Check below for the returned results from your search. If you were unable to find<br>
        your transaction change the search criteria and try to use more accurate details.
      </div>
    <?php }
    else { ?>

      <div class="title">Transaction History</div>
      <div class="desc">
        This is your transactions history, every payment you’ve received is saved below and<br>
        you can get it’s full details such as the payment amount, date, payer address etc...
      </div>

    <?php } ?>
    <div class="divider"></div>
    <?php if (isset($_GET['search']) == true) { ?>
      <div class="title">Seach for another transaction</div>
    <?php }
    else { ?>
      <div class="title">Seach for a transaction</div>
    <?php } ?>

    <div class="test" style="height: 45px; margin-top: 15px;">
      <form action="index.php?<?php echo @$_GET['search']; ?>" method="get">
        <select name="search">
          <option value="name">Client Name:</option>
          <option value="email">Client Email:</option>
          <option value="tnx_id">Transaction ID:</option>
          <option value="amount">Amount:</option>
        </select>
        <input type="text" name="term" placeholder="Search"/>
        <input type="submit" value="search"/>
        <!--<input type="image" name="submit" src="img/search_btn.png"/>-->
      </form>
    </div>

  </div>

  <div id="transactions_table">
    <!--Add results -->
    <div class="records round">
      <div class="pagination-title-parent">
        <div class="pagination-title">
          <div class="tdate"><p>
              <a href="?search=<?php echo $_GET['search'] ?>&term=<?php echo $_GET['term'] ?>&order=date&<?php if ($_GET['accending'] == 'true') {
                echo 'accending=false';
              }
              else {
                echo 'accending=true';
              } ?>">Date</a></p></div>
          <div class="tname"><p>
              <a href="?search=<?php echo $_GET['search'] ?>&term=<?php echo $_GET['term'] ?>&order=name">Name</a></p>
          </div>
          <div class="tamount"><p>Amount</p></div>
          <div class="temail"><p>
              <a href="?search=<?php echo $_GET['search'] ?>&term=<?php echo $_GET['term'] ?>&order=email">Email</a></p>
          </div>
          <div class="tcomments"><p>Project Number</p></div>
          <div class="ttxnid"><p>Txn ID</p></div>
          <div class="tsource"><p>Source</p></div>
        </div>
      </div>
      <?php
      if ((int) (@$_GET["page"] < 0)) {
        header("Location: index.php?page=1");
        die;
      }
      else {

        //show records

        #echo "SELECT *  FROM {$statement} LIMIT {$startpoint} , {$limit}";
        $query = $db->query("SELECT *  FROM {$statement} LIMIT {$startpoint} , {$limit}");
        if (($row = $query->num_rows) < 1) {
          echo '<div class="bigmessage">No transactions found.</div>';
        }
        while ($row = $query->fetch_assoc()) {
          ?>
          <div class="record round">
            <div class="date"><?php echo date("d/m/y", strtotime($row['payment_date'])); ?></div>
            <div class="vdiv"></div>
            <div class="name" title="<?php echo $row['name'] . ' ' . $row['surname']; ?>"><?php echo $row['name'] . ' ' . $row['surname']; ?></div>
            <div class="vdiv"></div>
            <div class="amount"><?php echo $row['paid_amount']; ?></div>
            <div class="vdiv"></div>
            <div class="email" title="<?php echo $row['email']; ?>"><?php echo $row['email']; ?></div>
            <div class="vdiv"></div>
            <div class="comments" title="<?php echo $row['comments']; ?>"><?php echo $row['comments']; ?></div>
            <div class="vdiv"></div>
            <div class="txnid"><?php echo $row['transaction_id']; ?></div>
            <div class="vdiv"></div>
            <div class="source"><?php echo $row['source']; ?></div>
            <div class="vdiv"></div>
            <div class="more_details">
              <a href="fulldetails.php?order_id=<?php echo $row['order_id']; ?>"><img border="0" title="Full Details" src="img/more_.png"/></a>
            </div>
          </div>

        <?php
        }
      }
      ?>
    </div>
    <div class="pgcontainer">
      <?php

      echo '<div style="float:right; margin-right: 5px;">' . pagination($statement, $limit, $page) . '</div>';
      ?>
    </div>
    <!--End -->
  </div>

</div>
<div id="footer"><p>Copyright © <?php echo date('Y'); ?></p></div>
</body>
</html>
