<?php

/**
 * Damos awesome script
 *
 *
 */


//Paypal Subscriptions
//https://www.paypal.com/au/cgi-bin/webscr?cmd=_pdn_subscr_techview_outside

require('inc/config.php');
require('inc/projectList.php');

//Load the projects list
$projects = new projectList('inc/projects.txt');

//Was a project preselected on the querystring?
if (isset($_GET['proj']) && !empty($_GET['proj'])) {
  $preselect = $_GET['proj'];
  if (!$projects->find($preselect)) {
    $preselect = NULL;
  }
}
else {
  $preselect = NULL;
}

//Preselected Dollar value
$standard_amounts = array(
  30,
  50,
  100,
  250,
  500,
);
if (isset($_GET['amount']) && !empty($_GET['amount'])) {
  if (in_array($_GET['amount'], $standard_amounts)) {
    $amount = $_GET['amount'];
  }
  else {
    //Use a custom amount instead of a standard amount
    $custom_amount = intval($_GET['amount']);
    $amount = NULL;
  }
}
else {
  $amount = NULL;
}

//Allow custom amount
if (isset($_GET['ca']) && !empty($_GET['ca'])) {
  $allow_custom = true;
}
else {
  $allow_custom = false;
}


//Source supplied as a parameter
if (isset($_GET['source']) && !empty($_GET['source'])) {
  $source = $_GET['source'];
}
else {
  $source = null;
}



//Automated recurring payment?
if (isset($_GET['r']) && !empty($_GET['r'])) {
  $recurring = true;
}
else {
  $recurring = false;
}

//Cover admin fee
if (isset($_GET['cf']) && !empty($_GET['cf'])) {
  $cover_fee = true;
}
else {
  $cover_fee = false;
}


//Render the "SELECTED="SELECTED" for an option if the amount was preselected
function check_selected($amount, $preselected)
{
  if ($amount == $preselected) {
    return ' selected="SELECTED" ';
  }
  return '';
}




?><!DOCTYPE html>
<html lang="en">
<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="">
  <meta name="author" content="">

  <!-- Favicons -->
  <link rel="apple-touch-icon-precomposed" sizes="144x144" href="images/apple-touch-icon-144-precomposed.png">
  <link rel="apple-touch-icon-precomposed" sizes="114x114" href="images/apple-touch-icon-114-precomposed.png">
  <link rel="apple-touch-icon-precomposed" sizes="72x72" href="images/apple-touch-icon-72-precomposed.png">
  <link rel="apple-touch-icon-precomposed" href="images/apple-touch-icon-57-precomposed.png">
  <link rel="shortcut icon" href="images/favicon.png">

  <title>Secure Paypal Donation | Global Development Group</title>

  <!-- Bootstrap core CSS -->
  <link href="css/bootstrap.css" rel="stylesheet">

  <!-- Custom styles for this template -->
  <link href="css/jumbotron-narrow.css" rel="stylesheet">

  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="inc/html5shiv.js"></script>
  <script src="inc/respond.min.js"></script>
  <![endif]-->
  <link rel="stylesheet" type="text/css" href="jquery.lightbox/js/lightbox/themes/default/jquery.lightbox.css"/>
  <link rel="stylesheet" type="text/css" href="css/select2.css"/>
  <script src="//ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js" type="text/javascript"></script>
  <script type="text/javascript" src="jquery.lightbox/js/lightbox/jquery.lightbox.min.js"></script>
  <script type="text/javascript" src="inc/charCount.js"></script>
  <script type="text/javascript" src="inc/select2.js"></script>
  <style type="text/css">
    .jquery-lightbox-buttons .button-themeforest {
      font-size:12px;
      font-weight:bold;
      text-decoration:none;
    }

    .jquery-lightbox-buttons .button-themeforest:hover {
      text-decoration:underline;
    }
  </style>
  <script type="text/javascript">
    jQuery(document).ready(function ($) {
      $('.lightbox').lightbox();
    });
  </script>
  <script type="text/javascript">
    $(document).ready(function () {

      <?php if($preselect){
          print 'var preselected = true;';
          ?>
      $('[name=item_name]').val('<?php print $projects->find($preselect); ?>');
      <?php
      } else {
          print 'var preselected = false;';
      }?>

      //custom usage
      $("#custom").charCount({
                               allowed: 255,
                               warning: 225,
                               counterText: 'Characters left: '
                             });

      if (!preselected) {
        $("#select_project").select2();
      }

      $("#amount").select2();

    });

  </script>

  <script type="text/javascript">
    jQuery(document).ready(function ($) {
      $("a.themeforest").lightbox({
                                    buttons: [
                                      {
                                        'class': 'button-themeforest',
                                        'html': 'OK Continue',
                                        'callback': function (url, object, anchor) {
                                          title = $(anchor).attr('alt').split('|');
                                          window.location.href = title[0];
                                        }
                                      },
                                      {
                                        'class': 'button-themeforest',
                                        'html': 'Use old method',
                                        'callback': function (url, object, anchor) {
                                          title = $(anchor).attr('alt').split('|');
                                          window.location.href = title[1];
                                        }
                                      }
                                    ]
                                  });
    });
  </script>
  <script>
    function myFunction() {
      window.close()
      window.open("http://www.gdg.org.au/Give");
    }
  </script>
</head>

<body>

<!-- Wrap all page content here -->
<div id="wrap">

  

  <div class="container">

    <!-- top image -->

    <!------------------------------------------
     insert form
     --------------------------------------------->
    <div class="row">
      <div class="col-lg-12">
        <form name="_xclick" id="_xclick" action="https://www.paypal.com/cgi-bin/webscr"
              method="post" target="self" class="form-horizontal" role="form">
          <input type="hidden" name="cmd" value="_xclick" id="cmd">
          <input type="hidden" name="business" value="<?php echo PAYPAL_ADDRESS; ?>">
          <input type="hidden" name="currency_code" value="<?php echo CURRENCY_CODE; ?>">
          <input type="hidden" name="item_name" value="GDG General Fund (J050)">
          <input type="hidden" name="no_shipping" value="1">
          <?php

          //Handle source reference supplied as part of the querystring. Pass this to paypal
          //If we want to have more than one piece of info here then need to expand this whole process...
          //http://stackoverflow.com/questions/16780719/paypal-ipn-custom-variables?rq=1
          if (!empty($source)) {
            echo '<input type="hidden" name="custom" value="' . $source . '">';
          }
          ?>
          <!-- to -->
          <div class="form-group">
            <label for="donate" class="col-lg-2 control-label">Donate to</label>

            <div class="col-lg-10">
              <?php if (!$preselect) { ?>
                <select name="select_project" id="select_project" style="width:100%;">
                  <?php echo $projects->getOptionsList($preselect); ?>
                  <option value="other_project">Other Project</option>
                </select>
                <br>
                <div id="enterproject">
                  Enter project: (all donations are to GDG: invalid preferences will support J050)<br>
                  <input class="form-control" type="text" name="enter_project" id="custom_project"/>
                </div>
              <?php
              }
              else {
                //Preselected
                ?>Project:
                <span class="project_name"><?php print $preselect . ' - ' . $projects->find($preselect); ?></span>
                <input type="hidden" name="select_project" id="select_project" value="<?php print $projects->find($preselect); ?>"/>

              <?php } ?>
            </div>
          </div>

          <!-- amount -->
          <div class="form-group">
            <label for="amount" class="col-lg-2 control-label">Amount</label>

            <div class="col-lg-10">
              <?php if ((!$amount && !$custom_amount) || $allow_custom):

                //Standard Amounts

                ?>
                <select name="preset_amount" id="preset_amount" class="form-control">
                  <option value="30" <?php print check_selected(30, $amount); ?>>
                    30 <?php echo CURRENCY_CODE; ?></option>
                  <option value="50" <?php print check_selected(50, $amount); ?>>
                    50 <?php echo CURRENCY_CODE; ?></option>
                  <option value="100" <?php print check_selected(100, $amount); ?>>
                    100 <?php echo CURRENCY_CODE; ?></option>
                  <option value="250" <?php print check_selected(250, $amount); ?>>
                    250 <?php echo CURRENCY_CODE; ?></option>
                  <option value="500" <?php print check_selected(500, $amount); ?>>
                    500 <?php echo CURRENCY_CODE; ?></option>
                  <option value="Other" <?php if ($custom_amount) {
                    echo 'selected="selected"';
                  }?>>Other amount
                  </option>
                </select>
				
                <div id="custom_price">
                  Enter Amount: (<?php echo CURRENCY_CODE; ?>) <br/>
                  <input type="text" class="form-control" name="custom_amount" id="custom_amount" placeholder="e.g.: 350" value="<?php echo $custom_amount; ?>"/>
                </div>
              <?php

              else:

                //This is a prefilled, fixed amount

                ?><div class="prefilled_amount"><?php
                //Print the prefilled value
                echo '$';
                echo $custom_amount ? $custom_amount : $amount;
                echo '  ' . CURRENCY_CODE; ?></div>
                <input type="hidden" name="preset_amount" id="preset_amount" value="<?php echo $amount ? $amount : 'Other'; ?>"/>
                <input type="hidden" name="custom_amount" id="custom_amount" value="<?php echo $custom_amount; ?>"/>
              <?php endif; ?>
              <input type="hidden" name="return" value="<?php echo RETURN_URL; ?>">
              <input type="hidden" name="notify_url" value="<?php echo IPN_URL; ?>"/>

            </div>
          </div>
          <div class="form-group">
            <div class="col-lg-offset-2 col-lg-10">
              <div class="checkbox">
                <?php if (!$cover_fee): ?>
                  <label>
                    <input type="checkbox" name="cover_fee" id="cover_fee"/>&nbsp;Add an additional 1.1% *(+30c) to help offset
                    PayPal fees
                  </label>
                <?php else: ?>
                  <div class="cover_fee">An extra 1.1% (+30c) will be added to your donation to help offset PayPal costs</div>
                  <input type="hidden" name="cover_fee" id="cover_fee" value="1" checked="checked"/>
                <?php endif; ?>
              </div>
            </div>
          </div>
          <div class="form-group">
            <div class="col-lg-offset-2 col-lg-10">
              <?php if (!$recurring): ?>
              <div class="checkbox">
                <label>
                  <input type="checkbox" name="subscribe" id="subscribe"/>&nbsp;Setup a monthly recurring donation*
                </label>
                <?php else: ?>
                  <input type="hidden" value="subscribe" id="subscribe" checked="checked"/>
                  <span>This is a recurring monthly donation*</span>
                <?php
                endif;
                ?>

                <div id="sub_fields"></div>
              </div>
            </div>
          </div>
          <!-- Replaced with a hidden field used for the source querystring value
<!--          <div class="form-group" style="display: none">-->
          <!--            <label for="option" class="col-lg-2 control-label">Optional</label>-->
          <!---->
          <!--            <div class="col-lg-10">-->
          <!--              <textarea class="form-control" rows="3" id="custom" name="custom" placeholder="This payment is for..."></textarea>-->
          <!--            </div>-->
          <!--          </div>-->

          <div class="form-group">
            <div class="col-lg-offset-2 col-lg-10">
              <button class="btn btn-lg btn-primary btn-block" background-color="rgb(180, 208, 18) type="submit">Donate Now*</button>
            </div>
          </div>
        </form>


      </div>


      <div style="margin-top: 30px;">
        <p style="color: #777; font-style:italic; font-size:12px">*All gifts over $2 are tax deductible. Donations are received subject to <a href="http://www.gdg.org.au/policy" target="_blank">terms and conditions.</a></br>To change or cancel the frequency of your donation,
          log in to your PayPal Account.
          <a href="https://www.paypal.com/au/webapps/mpp/how-paypal-works" target="_blank"> Why use
            PayPal?</a><a href="http://www.globaldevelopmentgroup.org/au/donate/paypal/dont-like-paypal/" target="_blank">
            Don't like PayPal?</a></p>
      </div>


    </div>
    <!------------------------------------------
           end form
   --------------------------------------------->


  </div>
  <!-- /container -->
</div>
<!-- /wrap -->

<div id="footer">
  <div class="container">
    <p class="text-muted credit">&copy; Copyright 2002-<?php echo date("Y")?> Global Development Group</p>
  </div>
</div>


<!-- Bootstrap core JavaScript
================================================== -->
<script src="inc/bootstrap.js"></script>
<script type="text/javascript">
  $(document).ready(
    function () {

      <?php if (!$custom_amount) {
                    ?>
      $("#custom_price").hide();
      <?php } ?>

      $("#enterproject").hide();

      $("select[name=select_project]").change(function () {
        var $this = $(this);
        if ($this.val() == 'other_project') {
          $("#enterproject").show();

          var enter_pro_val = $('[name=enter_project]').val();

          if (enter_pro_val) {
            $('[name=item_name]').val(enter_pro_val);
          }
        }
        else {
          $("#enterproject").hide();
          if ($this.val() != 'Select Project') {
            $('[name=item_name]').val($this.val());

          }
        }
      });

      $("[name=enter_project]").change(function () {
        var value = $(this).val();
        if (value) {
          $('[name=item_name]').val(value);
        }
      });

      $("select[name=preset_amount]").change(function () {
        var $this = $(this);
        if ($this.val() == 'Other') {
          $("#custom_price").show();
          // $("#custom_price").append('<input type="text" name="amount" placeholder="2500"/>
          //
          <?php echo CURRENCY_CODE; ?>
          //');
        }
        else {
          //      document.getElementById('custom_price').innerHTML = "";
          //      document.getElementById('custom_price').innerHTML = "Custom price:<br>";
          $("#custom_price").hide();
        }
      });


      $("#cover_fee").change(function () {
        var value = $(this).attr('checked');
        if (value == 'checked') {
          //Cover Fee has been turned on
        }
        else {

        }
      });


      // =====================================
      //  Form submission handler
      // =====================================
      $("#_xclick").submit(
        function (e) {
          var toPay = $('#preset_amount').val();
          var addDescription = '';

          //Handle custom amount
          if ($('#preset_amount').val() == 'Other') {
            toPay = $('#custom_amount').val();
          }
          else {
            //PreSet amount
            toPay = $('#preset_amount').val();
          }

	  //Minimum amount is $2
          if (toPay < 2) {
            e.preventDefault();
            $('<div id="specifyMin">Minimum donation amount is $2</div>').insertAfter('#custom_amount');
            return false;
          }
          else {
            $('#specifyMin').remove();
          }

          //Administration Fee has been turned on?
          if ($("#cover_fee").attr('checked') == 'checked') {
            // toPay = toPay + 0.30 (wasn't working!!)
			toPay = (toPay/98.9*100)+ 0.3033; //this is 30c / 98.9%
            //Round to nearest cent
            toPay = ((Math.round(toPay*100))/100)
			addDescription = ' (&offset)';
            $('[name=item_name]').val($('[name=item_name]').val() + addDescription);
          }
          <?php
          //Add Project ID to preselected projects
          if($preselect): ?>
          $('[name=item_name]').val('<?php print $preselect; ?> - ' + $('[name=item_name]').val());
          <?php endif; ?>


          //Subscription?
          if ($("#subscribe").attr('checked') == 'checked') {
            $('#cmd').val("_xclick-subscriptions");
            $('#sub_fields').html(
                '<input type="hidden" name="a3" value="' + toPay + '" />' +
                '<input type="hidden" name="p3" value="1" />' + //Interval
                '<input type="hidden" name="t3" value="M" />' + //Monthly
                '<input type="hidden" name="src" value="1">' +
                '<input type="hidden" name="sra" value="1">'
            );
          }
          else {
            //One-off payment
            $('#cmd').val("_xclick");
            $('#sub_fields').html('<input type="hidden" name="amount" value="' + toPay + '" />');

          }

        }
      );

    }
  );

</script>
<!-- Placed at the end of the document so the pages load faster -->


</body>
</html>
